Description

Currently, most locales define translations for Array#to_sentence using sentence_connector and skip_last_comma. However, these

keys were replaced in Rails 2.3 (Release note) by last_word_connector, two_words_connector, and words_connector.

This patch updates the old keys to the new ones so that Array#to_sentence works as expected. The changes follow these rules:

Values for the new keys are taken from the rails-i18n gem's locale settings .

Locales that already define the new keys are left unchanged.

zh (zh-CN) is aligned with the zh-TW settings.

Redmine currently does not use Array#to_sentence, so this patch should not affect any functionality or UI. However, some third-party

plugins might use it.

I confirmed that all tests, including system tests, pass after applying this patch. Here’s how Array#to_sentence behaves with the

updated translations:

$ bin/rails console

redmine-app(dev)> array = ['Redmine', 'Ruby', 'Rails', 'ルビー', '紅寶石']

=> ["Redmine", "Ruby", "Rails", "ルビー", "紅寶石"]

redmine-app(dev)> array.to_sentence(locale: :en)

=> "Redmine, Ruby, Rails, ルビー, and 紅寶石" 

redmine-app(dev)> array.to_sentence(locale: :ja)

=> "Redmine、Ruby、Rails、ルビー、紅寶石" 

redmine-app(dev)> array.to_sentence(locale: :zh)

=> "Redmine, Ruby, Rails, ルビー, 和 紅寶石" 

Associated revisions

Revision 23659 - 2025-04-16 02:15 - Go MAEDA

Updates translations for Array#to_sentence (#42580).

Patch by Katsuya HIDAKA (user:hidakatsuya).

History

#1 - 2025-04-15 02:57 - Go MAEDA

- Tracker changed from Patch to Defect

- Subject changed from Updates translations for Array#to_sentence to Array#to_sentence produces incorrect output due to missing translation keys

- Status changed from New to Confirmed

- Target version set to 6.1.0

#2 - 2025-04-15 03:16 - Go MAEDA

Currently, Array#to_sentence produces incorrect output as follows. The patch fixes this behavior.

Current behavior:

redmine-app(dev)> %w(a b c).to_sentence(locale: :ja)

=> "a, b, and c" 

redmine-app(dev)> %w(a b c).to_sentence(locale: :zh)

=> "a, b, and c" 
https://api.rubyonrails.org/classes/Array.html#method-i-to_sentence
https://guides.rubyonrails.org/2_3_release_notes.html#deprecated
https://github.com/svenfuchs/rails-i18n
https://github.com/svenfuchs/rails-i18n/tree/master/rails/locale


redmine-app(dev)> %w(a b c).to_sentence(locale: :en)

=> "a, b, and c" 

 Expected behavior:

redmine-app(dev)> %w(a b c).to_sentence(locale: :ja)

=> "a、b、c" 

redmine-app(dev)> %w(a b c).to_sentence(locale: :zh)

=> "a, b, 和 c" 

redmine-app(dev)> %w(a b c).to_sentence(locale: :en)

=> "a, b, and c" 

#3 - 2025-04-16 02:16 - Go MAEDA

- Status changed from Confirmed to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the fix in r23659. Thank you.

Files
